% System Model
global A B Hxp h Hu hu nx nu gamma Ku
gamma = 0.90;
sys=0;
if sys==1
   A = [0.3 -0.2;0.1 0.1];
   B = [0.2 0.4;0.4 0.5];
elseif sys==0
A=[1 0.2;0 1];
B=[0.22;0.2];
end
%%
% Number of States
nx=size(A,2);
% Number of Inputs
nu=size(B,2);
% State Constraints
Hx=[eye(nx);-eye(nx)];
hx=5*ones(2*nx,1);
X=Polyhedron(Hx,hx);
% Number of State Constraints
nbox=size(Hx,1);
Hxp=zeros(nbox,nx);
for i=1:nbox
Hxp(i,:)=Hx(i,:)/hx(i);
end
% Input Constraints
Hu=[eye(nu);-eye(nu)];
hu=3*ones(2*nu,1);

%% Optimization
P = sdpvar(nx,nx);
Y = sdpvar(nu,nx);

Scont=[gamma*P P*A'+Y'*B';A*P+B*Y P];

CState =[];
%CState = [1 Fi*P; Fi*P' P] - State Constraints
for i=1:nbox    
 CState{i}=[1 Hxp(i,:)*P;P*Hxp(i,:)' P];
end

%Sinput = [uimax^2 Yi;Yi' P] - Input Constraints
for i=1:nu
Sinput{i} = [hu(i)^2 Y(i,:);(Y(i,:))' P];
end

% Combining all constraints
constr=Scont>=0;
%constr=[];
for i=1:nu
    constr=[constr, Sinput{i}>=0];
end
for i=1:nbox
    constr=[constr, CState{i}>=0];
end

% solvesdp(constr, -trace(P)); %logdet()
solvesdp(constr, -logdet(P)); %logdet()

P = value(P);
Y = value(Y);
K = Y*P^-1;

% Gain for SOS optimization
Ku=K;

P1=inv(P);

%%  Plots
E=ellipsoid(P);
v=volume(E);
hold on
ellipplot_OK(P,1,'b');