%main
%SOS_main
%% SOS Programming
%clear all
global A B Hu hu gamma Hxp R Q Ku incr
% Optimization will run thrice i.e. once each for largest contractive ellipsoid
% and unconstrained ellipsoid and finally for SOS programming.
ContractiveEllipsoidsComputationConstrainedNew();      % Largest Ellipsoid x'*P1*x<=1 is obtained
unconstrained_P0();                                 % Obtaining unconstrained ellipsoid x'*P0*x<=1

h = ones(size(Hxp,1),1);
% Number of states
nx = size(A,2);
% Number of state Constraints
nxc = size(Hxp,1);
% Number of inputs
nu = size(B,2);
% Number of input constraints
nuc = size(Hu,1);

% Weight Matrices
% Input weight
R = eye(nu);
% State weight
Q = eye(nx);

save Modsave A B Q R Hxp Hu hu nx nu nuc P0 gamma

% Yalmip variables
% Current State
x = sdpvar(nx,1);
% Next State
xp = sdpvar(nx,1);
% Unconstrained Input law
u = Ku*x;
% x'*P1*x <=1 is the largest ellipsoid with linear feedback
Vx = x'*P1*x;
% Coefficients of Vx
Vxc = flip(coefficients(Vx));
Vxv = [x(1)^2;x(1)*x(2);x(2)^2];
% We want Vx to be greater than Vxprev
Vxprev = Vx;

%% Degree of the polynomials
% Degree of Vx
deg =8;
% Degree of u
udeg = 1;
% Degree of mu
mu1_deg = 8;
mu2_deg = 8;
mu3_deg = 9;
mu4_deg = 9;

s1_deg = 2;
s2_deg = 2;
s3_deg = 2;
s4_deg = 2;
s5_deg = 2;
s6_deg = 6;
s7_deg = 6;
% Degree of lambda
lambdau_deg = 6;
lambdae_deg = 9;
lambdaq_deg = 2;

% Incrementing points
incr = 0.05;

optacc = 1e-10;

save Degsave deg udeg mu1_deg mu2_deg mu3_deg mu4_deg s1_deg s2_deg s3_deg s4_deg s5_deg s6_deg s7_deg lambdau_deg lambdae_deg lambdaq_deg incr optacc



%% Loops
loop = true;
number=1;
while loop     
        uprev = u;
        Vxcprev = Vxc;
        % Iteration for lambda and s
        %[s1,s2,s3,s4,s5,s7,mu1,mu2,mu3,mu4,lambdae,lambdau,lambdaq]= lambda_s2(u,Vx,Vxc,x,xp,P0,lambdae_deg,lambdau_deg,lambdaq_deg);
        %Updating multipliers
        px = -(1-Vx)*(1-x'*P0*x);
        update_s1;  %Updating s1
        update_s2mu3 %Updating s2 and mu3
        %update_s6 done in update_uv
        update_s7 %Updating s7
        %pause(1)
        update_lambda %Updating all other multipliers
        pause(1)
        

        % Finding Point with maximum contraction
        if (number==20)
           point=[-1.0; -4.0]
           sprob_lambda = 1;
        else
            point = Point_Vx_2D_mod(Vxc)% Points_Vx_3D(Vx,u,x) for 3D
        end
        %point = Point_Vx_2D(Vxc,u,x)
        pointold = point;
        if (sprob_lambda == 0)
            point = point + incr*point
            %Otherwise, it is better to iterate on u and V, and not push
            %border of LF out.
            disp('Incrementing point')
        end
        plot(point(1),point(2),'bx')
        
        % Iteration for Vx and u
        
        update_uv
        
        if (sprob_uv ~=0)
            point = pointold; %Try iterating on V and u without pushing out region.
            update_uv
        end
        
  
        save Vsave loop number Vxc uc Ku
        
        clear all
        load Modsave
        load Degsave
        load Vsave
        
        x = sdpvar(nx,1)
        xp = sdpvar(nx,1)
        
        Vv = monolist(x,deg,2);
        Vpv = monolist(xp,deg,2);
        uv = monolist(x,udeg,1);
        
        Vx = Vxc'*Vv;
        u = uc'*uv;
        
        Vxprev = Vx;
        %plot_Vx (Vx,u,x);
       if(number>=2)
           plot_Vx (Vx,u,x);
            %break;
        end
        %break;
        % Displaying number of iterations
        disp(number)
        number=number+1;        
end
% Plotting Vx and its trajectories
%plot_Vx (Vx,u,x);

